   '***********************************************************************
   ' Kableo-metr
   ' omezeno do 216m - dle rozliseni enkoderu a poctu pulzu 65535
   ' pri stisku tl.1 po zapnuti, lze nastavit jeden krok enkoderu
   ' v 1.0 (22.2.2013)
   '
   ' Autor : Pavel Jank
   ' www.paja-trb.cz
   ' paja@paja-trb.cz
   '
   '***********************************************************************

$regfile = "m8def.dat"                                      'Soubor s deklaracemi - ATmega8
$crystal = 12000000                                         'Kmitoet osciltoru v Hz

Config Lcd = 16 * 2                                         'Typ LCD
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0       'Konfigurace pin LCD
Cursor Off

Declare Sub Klavesnice
Declare Sub Zadavani_hodnoty
Declare Sub Konstanta

Piezo Alias Portb.5 : Reset Piezo
Rele Alias Portb.4 : Reset Rele
Podsviceni Alias Portb.2 : Set Podsviceni

Opto1 Alias Pind.3
Opto2 Alias Pinb.0
Opto3 Alias Pinb.1

Config Pinb.0 = Input
Config Pinb.1 = Input
Config Portb.2 = Output
Config Portb.4 = Output
Config Portb.5 = Output

'Col1 Alias Portd.1
'Col2 Alias Portd.2
'Col3 Alias Portd.0
Row1 Alias Pind.7
Row2 Alias Pind.4
Row3 Alias Pind.5
Row4 Alias Pind.6

Ddrd = &B11110111                                           ' 0 je vstup, 1 je vstup  - PortD - nastaveni vstupu a vystupu  'Config Portd = &B11110111
Portd.3 = 1                                                 'pull-up
Portb.1 = 1
Portb.0 = 1

Config Int1 = Falling                                       'sestupna
On Int1 Enkoder
Enable Interrupts
Disable Int1                                                'Konfigurace peruen INT1

'Const Krok = 0.33083                                        '40 kroku, 1 otacka = 13,23cm
Dim Krok_save As Eram Word At 1                             'krok_save=33083
Dim Krok As Single
Dim Key As Byte
Dim Key1 As Byte , Key2 As Byte , Key3 As Byte , Key4 As Byte , Key5 As Byte
Dim Zadano As Word : Zadano = 0
Dim Pomocna As Word
Dim Pocet_zadani As Byte
Dim Pocetdilku As Word : Pocetdilku = 0
Dim Pocetotacek As Byte : Pocetotacek = 0
Dim Delka As Single
Dim Delka_fusing As String * 6
Dim Delka2 As Word
Dim Zmenaotacek As Word : Zmenaotacek = 0
Dim Znak As String * 3

'-------------------------------------------------------------------------------

Cls
Locate 1 , 1 : Lcd " Kabelo - metr "
Locate 2 , 1 : Lcd "PaJa 2013  v.1.0"
Wait 1

Call Klavesnice
If Key = 1 Then Call Konstanta

Cls
Locate 1 , 1 : Lcd " Kabelo - metr "
For Pocet_zadani = 16 To 1 Step -1
   Locate 2 , Pocet_zadani : Lcd " www.paja-trb.cz"
   Waitms 150
Next
Pocet_zadani = 0
Wait 1

Set Piezo : Waitms 100 : Reset Piezo

Start_zadavani:
Call Zadavani_hodnoty                                       'z klavesnice

'-------------------------------------------------------------------------------

Do
Sepnout_rele:
   Locate 1 , 1 : Lcd "Sepnout rele ? "
   Locate 2 , 1 : Lcd " * Ne  /  Ano # "
   Call Klavesnice
   If Key = 10 Then Reset Rele
   If Key = 11 Then Set Rele
   Waitms 50
Loop Until Key = 11 Or Key = 10
   Set Piezo : Waitms 40 : Reset Piezo

Enable Int1
Cls

Pomocna = Krok_save
Krok = Pomocna * 0.00001
Pocetdilku = 0

'===============================================================================

Do

Delka = Pocetdilku * Krok
Delka2 = Delka                                              'prevod single na word
   If Delka >= 100 Then
      Delka = Delka * 0.01                                  'prepocet na metry
      Znak = "m  "                                          'zobrazeni spravne jednotky za cislem
   Else
      Znak = "cm "
   End If
Delka_fusing = Fusing(delka , "#.&&")                       '#.## ze zaokrouhlenim / #.&& bez zaokrouhleni

  Locate 1 , 1 : Lcd "Delka =" ; Delka_fusing ; Znak
  If Rele = 1 Then
      Locate 1 , 16 : Lcd "R"
  Elseif Rele = 0 Then
      Locate 1 , 16 : Lcd " "
  End If
  Locate 2 , 1 : Lcd "Zadano=" ; Key1 ; Key2 ; Key3 ; "m" ; Key4 ; Key5 ; "cm "

  'kontrola dosazene/prekrocene namerene delky kabelu
  If Zadano = Delka2 Then
     Locate 2 , 16 : Lcd "="
     Set Piezo : Reset Podsviceni : Waitms 40 : Set Podsviceni : Waitms 40 : Reset Piezo
     Reset Rele
  End If

  If Zadano < Delka2 And Delka2 < 215 Then                  'pri prekroceni delky je mozno * vynulovat mereni
     Locate 2 , 16 : Lcd ">"
     Reset Rele
        Call Klavesnice
        If Key = 10 Then
           Set Piezo : Waitms 100 : Reset Piezo
           Goto Sepnout_rele
        End If
        If Key = 11 Then
           Set Piezo : Waitms 100 : Reset Piezo
           Goto Start_zadavani
        End If

  End If
'  Waitms 50
Loop

End

'===============================================================================

Enkoder:                                                    'Opto1 je pri preruseni vzdy 0 - sestupna hrana

If Opto2 = 1 Then
   Incr Pocetdilku
   If Opto3 = 0 And Zmenaotacek < Pocetdilku Then
      Incr Pocetotacek
      Zmenaotacek = Pocetdilku + 35
   End If
Elseif Opto2 = 0 Then
   Decr Pocetdilku
   If Opto3 = 0 And Zmenaotacek > Pocetdilku Then
      If Pocetotacek > 1 Then Decr Pocetotacek
      If Pocetdilku > 36 Then Zmenaotacek = Pocetdilku - 35
   End If
End If

   Waitms 1
Return

'-------------------------------------------------------------------------


Sub Klavesnice
  Key = 16                                                  'odpovez ze nebylo nic stisknuto
  Ddrd = &B00000111                                         'PortD.7-3 In, 0-2 Out
  Waitms 150
  Portd = &B11111110                                        'PortD.0=0  -> Col3=0
  If Row1 = 0 Then Key = 3
  If Row2 = 0 Then Key = 6
  If Row3 = 0 Then Key = 9
  If Row4 = 0 Then Key = 11
  Waitms 2
  Portd = &B11111101                                        'PortD.1=0  -> Col1=0
  If Row1 = 0 Then Key = 1
  If Row2 = 0 Then Key = 4
  If Row3 = 0 Then Key = 7
  If Row4 = 0 Then Key = 10
  Waitms 2
  Portd = &B11111011                                        'PortD.2=0  -> Col2=0
  If Row1 = 0 Then Key = 2
  If Row2 = 0 Then Key = 5
  If Row3 = 0 Then Key = 8
  If Row4 = 0 Then Key = 0
  Waitms 2

End Sub

'-------------------------------------------------------------------------

Sub Zadavani_hodnoty
Disable Int1

Cls
Zadej_hodnotu:
Key1 = 0 : Key2 = 0 : Key3 = 0 : Key4 = 0 : Key5 = 0 : Pocet_zadani = 0 : Pocetdilku = 0
  Locate 1 , 1 : Lcd "Zadej delku v cm"

Do
  Call Klavesnice

  If Key = 10 And Pocet_zadani > 0 Then Pocet_zadani = Pocet_zadani - 1       '* mazani

     Locate 2 , 1 : Lcd "Zadano=         "
     Locate 2 , 8
     Select Case Pocet_zadani
       Case 1 : Lcd Key1 ; "  m"
       Case 2 :
                Lcd Key1 ; Key2 ; " m"
       Case 3 :
                Lcd Key1 ; Key2 ; Key3 ; "m    "
       Case 4 :
                Lcd Key1 ; Key2 ; Key3 ; "m" ; Key4 ; " cm  "
       Case 5 :
                Lcd Key1 ; Key2 ; Key3 ; "m" ; Key4 ; Key5 ; "cm "
     End Select

  If Key < 10 And Pocet_zadani < 5 Then
     Incr Pocet_zadani

     Select Case Pocet_zadani                               ' omezeni na max. 209m99cm
       Case 1 : Key1 = Key
                 If Key1 > 2 Then Key1 = 0
       Case 2 : Key2 = Key
                 If Key1 = 2 Then Key2 = 0
       Case 3 : Key3 = Key
       Case 4 : Key4 = Key
       Case 5 : Key5 = Key
     End Select
  End If

Loop Until Key = 11                                         '# konec Enter

   'konecny soucet na max. 59999
   Zadano = Key1 * 10000
   Pomocna = 1000 * Key2
   Zadano = Zadano + Pomocna
   Pomocna = 100 * Key3
   Zadano = Zadano + Pomocna
   Pomocna = 10 * Key4
   Zadano = Zadano + Pomocna
   Zadano = Zadano + Key5

   Cls
Do
   Locate 1 , 1 : Lcd "Zadano=" ; Key1 ; Key2 ; Key3 ; "m" ; Key4 ; Key5 ; "cm "
   Locate 2 , 1 : Lcd " * Ne  /  Ano #"
   Call Klavesnice
   If Key = 10 Then Goto Zadej_hodnotu
   Waitms 50
Loop Until Key = 11
   Set Piezo : Waitms 40 : Reset Piezo

End Sub

'----------------------------------------------------------------------------

Sub Konstanta

Set Piezo : Waitms 50 : Reset Piezo : Waitms 500
Zadej_konstantu:
Cls
Key1 = 0 : Key2 = 0 : Key3 = 0 : Key4 = 0 : Key5 = 0 : Pocet_zadani = 0
  Locate 1 , 1 : Lcd "Zadej 1 krok"

Do
  Call Klavesnice

  If Key = 10 And Pocet_zadani > 0 Then Pocet_zadani = Pocet_zadani - 1       '* mazani

     Locate 2 , 1 : Lcd "Krok=0.         "
     Locate 2 , 8
     Select Case Pocet_zadani
       Case 1 : Lcd Key1
       Case 2 :
                Lcd Key1 ; Key2
       Case 3 :
                Lcd Key1 ; Key2 ; Key3
       Case 4 :
                Lcd Key1 ; Key2 ; Key3 ; Key4
       Case 5 :
                Lcd Key1 ; Key2 ; Key3 ; Key4 ; Key5
     End Select

  If Key < 10 And Pocet_zadani < 5 Then
     Incr Pocet_zadani

     Select Case Pocet_zadani
       Case 1 : Key1 = Key
       Case 2 : Key2 = Key
       Case 3 : Key3 = Key
       Case 4 : Key4 = Key
       Case 5 : Key5 = Key
     End Select
  End If

Loop Until Key = 11                                         '# konec Enter

   'konecny soucet na max. 59999
   Zadano = Key1 * 10000
   Pomocna = 1000 * Key2
   Zadano = Zadano + Pomocna
   Pomocna = 100 * Key3
   Zadano = Zadano + Pomocna
   Pomocna = 10 * Key4
   Zadano = Zadano + Pomocna
   Zadano = Zadano + Key5

   Krok_save = Zadano                                       'ulozeni hodnoty do eeproom
   Krok = Zadano * 0.00001
   Cls
Do
   Locate 1 , 1 : Lcd "Krok=" ; Krok ; "    "
   Locate 2 , 1 : Lcd " * Ne  /  Ano #"
   Call Klavesnice
   If Key = 10 Then Goto Zadej_konstantu
   Waitms 50
Loop Until Key = 11
   Set Piezo : Waitms 40 : Reset Piezo

End Sub

' (c) PaJa-trb  2013 / www.paja-trb.cz / paja@paja-trb.cz